﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace rspmp3net
{
    public partial class Form13 : Form
    {
        public Form13()
        {
            InitializeComponent();
        }

        private void Form13_FormClosing(object sender, FormClosingEventArgs e)
        {
            System.Environment.Exit(0);
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start(linkLabel1.Text);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            IntPtr b = Form13.ActiveForm.Handle;
            int c = b.ToInt32();
            textBox1.Text = rspmp3net1.SelectFile("", "Select media file to open", "All supported files (*.mpg *.mp1 *.mp2 *.mp3 *.wav)|*.mpg;*.mp1;*.mp2;*.mp3;*.wav|All files (*.*)|*.*", "", c);

        }

        private void button2_Click(object sender, EventArgs e)
        {


            label1.Text = "Result: working...";
            this.Refresh();


            //  'For information about how to use the normalization functions visit :
            // 'http://rspsoftware.bighost.com.br/rspnormalization.htm
            int ret;


            ret = rspmp3net1.GenerateVolumeTag(textBox1.Text);

            switch (ret)
            {

                case 0:
                    label1.Text = "Result: no error, tag ok ";
                    break;
                case 1:
                    label1.Text = "Result: file don't exist or too small  ";
                    break;
                case 2:
                    label1.Text = "Result: cannot open file to read or write ";
                    break;
                case 3:
                    label1.Text = "Result: file is read only  ";
                    break;
                case 4:
                    label1.Text = "Result: unable to generate the volume normalization value  ";
                    break;
                default:
                    label1.Text = "Result: unexpected error";
                    break;

            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            label1.Text = "Result: working...";
            this.Refresh();


            // 'For information about how to use the normalization functions visit :
            // 'http://rspsoftware.bighost.com.br/rspnormalization.htm
            int ret;
            ret = rspmp3net1.CheckVolumeTag(textBox1.Text);

            switch (ret)
            {

                case 0:
                    label1.Text = "Result: file have volume tag ";
                    break;
                case 1:
                    label1.Text = "Result: file don't have volume tag ";
                    break;

            }

        }

        private void Form13_Load(object sender, EventArgs e)
        {

        }
    }
}
