﻿using System;
using System.IO;
//using System.Linq;
using System.Windows.Forms;

namespace rspmp3net
{
    public partial class Form7 : Form
    {

        public int exists = 0;

        public int finish_it = 0;

        public string filename;

        public Form7()
        {


            InitializeComponent();
        }

        private int already = 0;
        private void Form7_Load(object sender, EventArgs e)
        {
            label10.Text = "";

            if (0 == already)
            {
                rspmp3net1.Generate_ID3v1Genre();
                already++;
            }
            int ret;

            Combo1.Enabled = false;
            v1album.Enabled = false;
            v1artist.Enabled = false;
            v1comment.Enabled = false;
            v1title.Enabled = false;
            v1track.Enabled = false;
            v1year.Enabled = false;


            check1.CheckState = CheckState.Unchecked;

            v1title.Text = "";


            v1track.Text = "";

            Combo1.SelectedIndex = -1;
            Combo1.Text = "";
            v1album.Text = "";
            v1artist.Text = "";
            v1comment.Text = "";
            v1year.Text = "";

            combo2.Enabled = false;
            v2album.Enabled = false;
            v2artist.Enabled = false;
            v2comment.Enabled = false;
            v2composer.Enabled = false;
            v2copyright.Enabled = false;
            v2encodedby.Enabled = false;
            v2originalart.Enabled = false;
            v2title.Enabled = false;
            v2track.Enabled = false;
            v2url.Enabled = false;
            v2year.Enabled = false;


            check2.CheckState = CheckState.Unchecked;
            combo2.Text = "";
            v2album.Text = "";
            v2artist.Text = "";
            v2comment.Text = ""; ;
            v2composer.Text = "";
            v2copyright.Text = ""; ;
            v2encodedby.Text = "";
            v2originalart.Text = "";
            v2title.Text = "";
            v2track.Text = "";
            v2url.Text = "";
            v2year.Text = "";



            if (false == File.Exists(filename))
            {

                if (filename.Length > 0)
                {
                    label22.Text = "File don't exist";
                }
                else
                {
                    label22.Text = "";
                }
                return;
            }


            if (filename.Length > 0)
            {
                label10.Text = filename;
                int track = 0;
                string title = "";
                string artist = "";
                string album = "";
                string year = "";
                int genre = 0;
                string comment = "";



                ret = rspmp3net1.Read_ID3_v1_tag(filename, ref track, ref title, ref artist, ref album, ref year, ref genre, ref comment);

                if (0 == ret)
                {

                    Combo1.Enabled = true;
                    v1album.Enabled = true;
                    v1artist.Enabled = true;
                    v1comment.Enabled = true;
                    v1title.Enabled = true;
                    v1track.Enabled = true;
                    v1year.Enabled = true;


                    check1.CheckState = CheckState.Checked;

                    v1title.Text = title;

                    if (track != 0)
                    {
                        v1track.Text = track.ToString();
                    }
                    else
                    {
                        v1track.Text = "";
                    }
                    //MessageBox.Show("antes " + genre.ToString());
                    Combo1.SelectedIndex = genre;
                    // MessageBox.Show("depois " + genre.ToString());
                    v1album.Text = album;
                    v1artist.Text = artist;
                    v1comment.Text = comment;
                    v1year.Text = year;

                }
                else
                {
                    Combo1.Enabled = false;
                    v1album.Enabled = false;
                    v1artist.Enabled = false;
                    v1comment.Enabled = false;
                    v1title.Enabled = false;
                    v1track.Enabled = false;
                    v1year.Enabled = false;


                    check1.CheckState = CheckState.Unchecked;

                    v1title.Text = "";


                    v1track.Text = "";


                    Combo1.Text = "";
                    v1album.Text = "";
                    v1artist.Text = "";
                    v1comment.Text = "";
                    v1year.Text = "";

                }


                string Album_v2 = "";
                string Artist_v2 = "";
                string Comment_v2 = "";
                string Composer_v2 = "";
                string Copyright_v2 = "";
                string Encodedby_v2 = "";
                string Genre_v2 = "";
                string Originalartist_v2 = "";
                string Title_v2 = "";
                string Track_v2 = "";
                string Url_v2 = "";
                string Year_v2 = "";

                ret = rspmp3net1.Read_ID3_v2_tag(filename, ref Track_v2, ref
Title_v2, ref Artist_v2, ref Album_v2, ref Year_v2, ref Genre_v2, ref
Comment_v2, ref Encodedby_v2, ref Url_v2, ref Copyright_v2, ref
Originalartist_v2, ref Composer_v2);




                if (0 == ret)
                {

                    check2.CheckState = CheckState.Checked;

                    combo2.Enabled = true;
                    v2album.Enabled = true;
                    v2artist.Enabled = true;
                    v2comment.Enabled = true;
                    v2composer.Enabled = true;
                    v2copyright.Enabled = true;
                    v2encodedby.Enabled = true;
                    v2originalart.Enabled = true;
                    v2title.Enabled = true;
                    v2track.Enabled = true;
                    v2url.Enabled = true;
                    v2year.Enabled = true;



                    combo2.Text = Genre_v2;
                    v2album.Text = Album_v2;
                    v2artist.Text = Artist_v2;
                    v2comment.Text = Comment_v2;
                    v2composer.Text = Composer_v2;
                    v2copyright.Text = Copyright_v2;
                    v2encodedby.Text = Encodedby_v2;
                    v2originalart.Text = Originalartist_v2;
                    v2title.Text = Title_v2;
                    v2track.Text = Track_v2;
                    v2url.Text = Url_v2;
                    v2year.Text = Year_v2;


                }
                else
                {


                    combo2.Enabled = false;
                    v2album.Enabled = false;
                    v2artist.Enabled = false;
                    v2comment.Enabled = false;
                    v2composer.Enabled = false;
                    v2copyright.Enabled = false;
                    v2encodedby.Enabled = false;
                    v2originalart.Enabled = false;
                    v2title.Enabled = false;
                    v2track.Enabled = false;
                    v2url.Enabled = false;
                    v2year.Enabled = false;


                    check2.CheckState = CheckState.Unchecked;
                    combo2.Text = "";
                    v2album.Text = "";
                    v2artist.Text = "";
                    v2comment.Text = ""; ;
                    v2composer.Text = "";
                    v2copyright.Text = ""; ;
                    v2encodedby.Text = "";
                    v2originalart.Text = "";
                    v2title.Text = "";
                    v2track.Text = "";
                    v2url.Text = "";
                    v2year.Text = "";


                }






            }


        }

        private void Form7_FormClosing(object sender, FormClosingEventArgs e)
        {

            exists = 0;

            if (finish_it != 0)
            {
                System.Environment.Exit(0);
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            IntPtr b = Form7.ActiveForm.Handle;
            int c = b.ToInt32();
            filename = rspmp3net1.SelectFile("", "Select media file to open", "All supported files (*.mpg *.mp1 *.mp2 *.mp3 *.wav)|*.mpg;*.mp1;*.mp2;*.mp3;*.wav|All files (*.*)|*.*", "", c);

            System.EventArgs d = new EventArgs();

            Form7_Load(this, d);

        }

        private void check1_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void check1_MouseUp(object sender, MouseEventArgs e)
        {


            if (check1.CheckState == CheckState.Checked)
            {

                Combo1.Enabled = true;
                v1album.Enabled = true;
                v1artist.Enabled = true;
                v1comment.Enabled = true;
                v1title.Enabled = true;
                v1track.Enabled = true;
                v1year.Enabled = true;
            }
            else
            {
                Combo1.Enabled = false;
                v1album.Enabled = false;
                v1artist.Enabled = false;
                v1comment.Enabled = false;
                v1title.Enabled = false;
                v1track.Enabled = false;
                v1year.Enabled = false;
            }

        }

        private void check2_MouseUp(object sender, MouseEventArgs e)
        {

            if (check2.CheckState == CheckState.Checked)
            {
                combo2.Enabled = true;
                v2album.Enabled = true;
                v2artist.Enabled = true;
                v2comment.Enabled = true;
                v2composer.Enabled = true;
                v2copyright.Enabled = true;
                v2encodedby.Enabled = true;
                v2originalart.Enabled = true;
                v2title.Enabled = true;
                v2track.Enabled = true;
                v2url.Enabled = true;
                v2year.Enabled = true;
            }
            else
            {
                combo2.Enabled = false;
                v2album.Enabled = false;
                v2artist.Enabled = false;
                v2comment.Enabled = false;
                v2composer.Enabled = false;
                v2copyright.Enabled = false;
                v2encodedby.Enabled = false;
                v2originalart.Enabled = false;
                v2title.Enabled = false;
                v2track.Enabled = false;
                v2url.Enabled = false;
                v2year.Enabled = false;
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {
            label22.Text = "Updating...";
            label22.Refresh();
            this.Refresh();


            if (false == File.Exists(filename))
            {

                if (filename.Length > 0)
                {
                    label22.Text = "File don't exist";
                }
                else
                {
                    label22.Text = "";
                }
                return;
            }


            int v1trackint;

            int genre = Combo1.SelectedIndex;
            try
            {
                v1trackint = int.Parse(v1track.Text);
            }
            catch
            {
                v1trackint = 0;
            }
            int ret;
            if (check1.CheckState == CheckState.Checked)
            {
                ret = rspmp3net1.Write_ID3_v1_tag(filename, v1trackint, v1title.Text, v1artist.Text, v1album.Text, v1year.Text, genre, v1comment.Text);

                switch (ret)
                {
                    case 0:
                        break;
                    case 1:
                        MessageBox.Show("Cannot open file ");
                        break;
                    case 2:
                        MessageBox.Show("ID3 v1 tag not found");
                        break;
                    case 3:
                        MessageBox.Show("Invalid mp3 file");
                        break;
                    case 4:
                        MessageBox.Show("File is read only ");
                        break;
                    default:
                        MessageBox.Show("Unexpected error");
                        break;

                }

            }
            else
            {


                ret = rspmp3net1.Remove_ID3V1_tag(filename);


                switch (ret)
                {
                    case 0:
                        break;
                    case 1:
                        MessageBox.Show("Cannot remove ID3 v1 tag while playing , stop the playback and try again");
                        break;

                    case 3:
                        MessageBox.Show("File is read only");
                        break;
                    default:
                        MessageBox.Show("Unexpected error");
                        break;

                }



            }

            if (check2.CheckState == CheckState.Checked)
            {

                ret = rspmp3net1.Write_ID3_v2_tag(filename, v2track.Text, v2title.Text, v2artist.Text, v2album.Text, v2year.Text, combo2.Text, v2comment.Text, v2encodedby.Text, v2url.Text, v2copyright.Text, v2originalart.Text, v2composer.Text);

                switch (ret)
                {
                    case 0:
                        break;
                    case 1:
                        MessageBox.Show("File is read only ");
                        break;
                    case 2:
                        MessageBox.Show("Unable to create temp file ");
                        break;
                    case 3:
                        MessageBox.Show("Cannot load data from file");
                        break;
                    case 4:
                        MessageBox.Show("Cannot open temp file to write");
                        break;
                    case 5:
                        MessageBox.Show("Cannot open input file to read ");
                        break;
                    case 6:
                        MessageBox.Show("Cannot open temp file to write");
                        break;
                    case 7:
                        MessageBox.Show("Cannot replace original file");
                        break;
                    case 8:
                        MessageBox.Show("Invalid ID3V2 tag");
                        break;
                    default:
                        MessageBox.Show("Unexpected error ");
                        break;
                }
            }
            else
            {
                ret = rspmp3net1.Remove_ID3V2_tag(filename);

                switch (ret)
                {
                    case 0:
                        break;
                    case 1:
                        MessageBox.Show("File is read only");
                        break;
                    case 2:
                        MessageBox.Show("Unable to create temp file");
                        break;
                    case 3:
                        MessageBox.Show("Cannot open input file to read");
                        break;
                    case 4:
                        MessageBox.Show("Cannot open temp file to write");
                        break;
                    case 5:
                        MessageBox.Show("Cannot replace original file");
                        break;
                    default:
                        MessageBox.Show("Unexpected error");
                        break;
                }
            }


            System.EventArgs d = new EventArgs();

            Form7_Load(this, d);
            label22.Text = "Done";

        }

        private void rspmp3net1_ID3v1GenreList(object Sender, MP3NetLibrary.ID3v1GenreListEventArgs e)
        {
            if (true == e.ClearFlag)
            {
                Combo1.Items.Clear();

                combo2.Items.Clear();
            }
            else
            {

                Combo1.Items.Add(e.Genre);
                combo2.Items.Add(e.Genre);
            }
        }
    }
}
