

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;




namespace rspmp3net
{
    public partial class Form8 : Form
    {

        public int exists = 0;
        MP3NetLibrary.RSPMP3Net rspmp3net1;

        private Form1 thecopy;
        public Form8(MP3NetLibrary.RSPMP3Net eu, Form1 eu2)
        {
            rspmp3net1 = eu;
            thecopy = eu2;
            InitializeComponent();
        }

        private void Form8_Load(object sender, EventArgs e)
        {

            rspmp3net1.ResetPlaylist();
            rspmp3net1.EnableRepeatPlaylist(true);

        }

        private void Form8_FormClosing(object sender, FormClosingEventArgs e)
        {
            exists = 0;
            thecopy.WindowState = FormWindowState.Normal;
        }






        private string getfilename(string file)
        {
            char[] eu;
            int i;

            eu = file.ToCharArray();
            string ola = "";

            //MessageBox.Show(eu.Length.ToString());

            for (i = eu.Length - 1; i > 0; i--)
            {

                if (eu[i] == '\\')
                {
                    i++;
                    goto achei;
                }

            }
            goto final;

        achei:

            for (; i < eu.Length; i++)
            {

                ola = ola + eu[i];
            }

            // MessageBox.Show (ola);
            return ola;

        final:

            return "";
        }
        private void listView1_DragDrop(object sender, DragEventArgs e)
        {
            // e.Data.ToString();

            string[] eu = (string[])e.Data.GetData(DataFormats.FileDrop);
            int i;
            for (i = 0; i < eu.Length; i++)
            {
                //  MessageBox.Show(eu[i]);
                string file = getfilename(eu[i]);
                listView1.Items.Add(file).SubItems.Add(eu[i]);
                rspmp3net1.AddItemToPlaylist();
            }
        }

        private void listView1_DragEnter(object sender, DragEventArgs e)
        {
            // MessageBox.Show("Drag enter");
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void checkBox1_MouseUp(object sender, MouseEventArgs e)
        {
            if (checkBox1.CheckState == CheckState.Checked)
            {

                rspmp3net1.EnableRepeatPlaylist(true);
            }
            else
            {
                rspmp3net1.EnableRepeatPlaylist(false);

            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            listView1.Clear();
            rspmp3net1.ResetPlaylist();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            rspmp3net1.CancelPlayback();
        }



        private void button1_Click(object sender, EventArgs e)
        {


            if (0 == listView1.Items.Count)
            {
                return;
            }


            // listView1.TopItem.Index.ToString();

            // MessageBox.Show(listView1.Items[0].SubItems[1].Text);
            listView1.Focus();
            listView1.Items[0].Selected = true;

            rspmp3net1.SetFilePlayingPlaylist(1);

            EventArgs n = new EventArgs();

            listView1_DoubleClick(this, n);

        }
        public string thefile = "";
        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            //MessageBox.Show(listView1.SelectedItems[0].SubItems[1].Text);
            thefile = listView1.SelectedItems[0].SubItems[1].Text;
            rspmp3net1.PlayFile(listView1.SelectedItems[0].SubItems[1].Text);
            //  MessageBox.Show(listView1.SelectedItems[0].Index.ToString());
            
            rspmp3net1.SetFilePlayingPlaylist(listView1.SelectedItems[0].Index+1);


        }


        public  void finished()
        {

            

            if (0 == exists)
            {
                
                return;
            }

            if (0 == listView1.Items.Count)
            {
               
                return;
            }
           

            int ret;
            if (checkBox2.CheckState == CheckState.Checked)
            {
                ret = rspmp3net1.GetShuffleNextItemPlaylist();

            }
            else
            {
               // Debug.Assert(0 == 1);
                ret = rspmp3net1.GetNextItemPlaylist();
            }
           
            if (-1 == ret)
            {

                
                return;
            }
            if (ret < 1)
            {
                MessageBox.Show("ret<1");
            }
            listView1.Items[ret-1].Selected = true;
            
            EventArgs n = new EventArgs();

            listView1_DoubleClick(this, n);
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
